
#ifndef LUBISHEV_DB_DRECORDS_H
#define LUBISHEV_DB_DRECORDS_H

#include <lubishev/DB.h>

namespace lubishev {

class DBDRecords : public DB {
    public:
        virtual QString createEvent(time_t start, time_t end);
        virtual QStringList eventTags(const QString &id);
        virtual QStringList eventsWithin(time_t start, time_t end);
        virtual void eventTimes(const QString &id, time_t *start, time_t *end);
        virtual void setDir(const QString &dir);
        virtual void setEventTags(const QString &id, const QStringList &list);
        virtual void setEventTimes(const QString &id, time_t start, time_t end);

    private:
        //! Return absolute path from ID.
        QString absPath(const QString &id);
        //! Create ID (file name).
        QString createID(time_t start);
        QStringList dateFiles(time_t date);
        void dateToStr(time_t date, QString &yearMonth, QString &day);
        //! Ensure directory hierarchy exists for the file.
        void ensureDirs(const QString &id);

        QString mDir;
};

} // namespace lubishev

#endif // LUBISHEV_DB_DRECORDS_H

